#define screenWidth 320
#define screenHeight 240
#define texWidth 32
#define texHeight 32
int mapWidth=24;
int mapHeight=24;

double posX = 50.0, posY = 5.5; //x and y start position
double dirX = -1.0, dirY = 0.0; //initial direction vector
double planeX = 0.0, planeY = 0.66; //the 2d raycaster version of camera plane

double ftime = 0; //time of current frame
double foldTime = 0; //time of previous frame

int temp, temp2, tx, ty, tr, tg, tb, ta;
string tempstring, tempstring2;

std::vector<Uint32> texture[11];

//sort algorithm
void combSort(int* order, double* dist, int amount)
{
  int gap = amount;
  bool swapped = false;
  while(gap > 1 || swapped)
  {
    //shrink factor 1.3
    gap = (gap * 10) / 13;
    if(gap == 9 || gap == 10) gap = 11;
    if (gap < 1) gap = 1;
    swapped = false;
    for (int i = 0; i < amount - gap; i++)
    {
      int j = i + gap;
      if (dist[i] < dist[j])
      {
        std::swap(dist[i], dist[j]);
        std::swap(order[i], order[j]);
        swapped = true;
      }
    }
  }
}

string its(int t, int s=0){
  string te;
  ostringstream *its_temp;
  its_temp = new ostringstream;
  (*its_temp) << t;
  te = (*its_temp).str();
  delete its_temp;
  if(s==0){ return te;
  }else{
    int d;
    d=s-te.length();
    if(d<0){
      return te;
    }else{
      while(d>0){
        te = "0" + te;
        d--;
      }
      return te;
    }
  }
}

int sti(string s){
  istringstream stringbuf(s);
  int t;
  stringbuf >> t;
  return t;
}

string itsmil(int t){
  tempstring=its(t);
  tempstring2="";
  temp=0; temp2=tempstring.length();

  for(int i=0; i<temp2; i++){
    tempstring2=tempstring[(temp2-1)-i]+tempstring2;
    if((temp==2 && temp2!=3) || (temp==5 && temp2!=6) || (temp==8 && temp2!=9))
      tempstring2=","+tempstring2;
    temp++;
  }
  return tempstring2;
}

int nmod(int t, int s){
  while(t<0) t+=s;
  return t%s;
}

string lowercase(string t){
  return strlwr((char *) t.c_str());
}

bool inbox(int x1, int y1, int x2, int y2, int tx, int ty){
  if(tx>=x1&&tx<=x2){
    if(ty>=y1&&ty<=y2){
      return true;
    }
  }
  return false;
}

bool inboxw(int x1, int y1, int w, int h, int tx, int ty){
  if(tx>=x1&&tx<=x1+w){
    if(ty>=y1&&ty<=y1+h){
      return true;
    }
  }
  return false;
}

